diff --git a/drivers/infiniband/sw/rfc/rfc_mr.c b/drivers/infiniband/sw/rfc/rfc_mr.c
index 75b559b..cfe0e89 100644
--- a/drivers/infiniband/sw/rfc/rfc_mr.c
+++ b/drivers/infiniband/sw/rfc/rfc_mr.c
@@ -304,7 +304,7 @@ static void lookup_iova(
 	}
 }
 
-void rfc_lookup_iova(
+static void rfc_lookup_iova(
 	struct rfc_mem	*mem,
 	u64			iova,
 	int			*m_out,
diff --git a/drivers/infiniband/sw/rfc/rfc_net.c b/drivers/infiniband/sw/rfc/rfc_net.c
index e850a39..4b5d91b 100644
--- a/drivers/infiniband/sw/rfc/rfc_net.c
+++ b/drivers/infiniband/sw/rfc/rfc_net.c
@@ -67,14 +67,14 @@ static DEFINE_SPINLOCK(rfc_net_lock);
 #define UNLOCK(x, y)	spin_unlock_irqrestore((x), (y))
 #define LOCK_INIT(x)	spin_lock_init((x))
 
-struct net_device *rfc_net_dev;
+static struct net_device *rfc_net_dev;
 struct rfc_skb_blk_push {
 	struct page *page1;
 	u32 daddr;
 	int len;
 	struct list_head    active_push_reqs;
 };
-struct list_head skb_blk_push_list;
+static struct list_head skb_blk_push_list;
 struct rfc_net_private {
 	struct napi_struct      napi;
 	struct net_device       *dev;
@@ -86,7 +86,7 @@ static unsigned char rfc_net_mac_addr[6]  = {
 
 };
 //struct page *xmit_page = NULL;
-struct work_struct net_blk_work;
+static struct work_struct net_blk_work;
 static struct workqueue_struct *net_blk_wrk_st;
 
 static void rfc_net_xfer_complete(struct bio *bio)
diff --git a/drivers/infiniband/sw/rfc/rfc_obj.c b/drivers/infiniband/sw/rfc/rfc_obj.c
index 474a3c1..83dbceb 100644
--- a/drivers/infiniband/sw/rfc/rfc_obj.c
+++ b/drivers/infiniband/sw/rfc/rfc_obj.c
@@ -50,7 +50,7 @@
 static LIST_HEAD(rfc_dev_list);
 static DEFINE_SPINLOCK(dev_list_lock); /* spinlock for device list */
 
-struct rfc_obj_info g_cb = {0};
+static struct rfc_obj_info g_cb = {0};
 
 struct rfc_dev *net_to_rfc(struct net_device *ndev)
 {
@@ -85,7 +85,7 @@ struct rfc_dev *get_rfc_by_name(const char *name)
 	return found;
 }
 
-struct rfc_dev *get_rfc_by_objname(const char *objname)
+static struct rfc_dev *get_rfc_by_objname(const char *objname)
 {
 	struct rfc_dev *rfc;
 	struct rfc_dev *found = NULL;
@@ -139,7 +139,7 @@ static int find_sgl_length(struct sg_table *rsg)
 	return length;
 }
 
-void print_sgl(struct sg_table *rsg)
+static void print_sgl(struct sg_table *rsg)
 {
 	struct scatterlist *sgl = rsg->sgl, *tmpsg;
 	int i = 0;
@@ -227,7 +227,7 @@ int rfc_send(struct rfc_dev *rfc,
 
 }
 
-int rfc_send_data_free(void *data, struct sg_table *rsg)
+static int rfc_send_data_free(void *data, struct sg_table *rsg)
 {
 	struct rfc_obj_info *obj = (struct rfc_obj_info *)data;
 
diff --git a/drivers/infiniband/sw/rfc/rfc_qp.c b/drivers/infiniband/sw/rfc/rfc_qp.c
index 32b42cf..a908b1d 100644
--- a/drivers/infiniband/sw/rfc/rfc_qp.c
+++ b/drivers/infiniband/sw/rfc/rfc_qp.c
@@ -41,7 +41,7 @@
 #include "rfc_queue.h"
 #include "rfc_task.h"
 
-char *rfc_qp_state_name[] = {
+static char *rfc_qp_state_name[] = {
 	[QP_STATE_RESET]	= "RESET",
 	[QP_STATE_INIT]		= "INIT",
 	[QP_STATE_READY]	= "READY",
diff --git a/drivers/infiniband/sw/rfc/rfc_resp.c b/drivers/infiniband/sw/rfc/rfc_resp.c
index a383105..7c2f3a5 100644
--- a/drivers/infiniband/sw/rfc/rfc_resp.c
+++ b/drivers/infiniband/sw/rfc/rfc_resp.c
@@ -699,7 +699,7 @@ static void build_rdma_network_hdr(union rdma_network_hdr *hdr,
 	iph->ttl        =       50;
 }
 
-struct page *ackpage;
+static struct page *ackpage;
 
 static enum resp_states rfc_resp_get_sgl(struct rfc_qp *qp,
 					struct rfc_obj_info *obj,
diff --git a/drivers/infiniband/sw/rfc/rfc_tb.c b/drivers/infiniband/sw/rfc/rfc_tb.c
index ba11a33..064453b 100644
--- a/drivers/infiniband/sw/rfc/rfc_tb.c
+++ b/drivers/infiniband/sw/rfc/rfc_tb.c
@@ -78,7 +78,7 @@ static DEFINE_SPINLOCK(rfc_req_lock);
 
 #define RFC_SKB_SECTOR 0xa5
 static u8 *dev_data;
-struct work_struct rfcwork;
+static struct work_struct rfcwork;
 
 struct rfc_data {
 	struct sg_table *sg_head;
@@ -90,7 +90,7 @@ struct rfc_data {
 	struct rdma_hdr_common *rdma_hdr;
 };
 
-struct list_head    rfc_obj_list;
+static struct list_head    rfc_obj_list;
 
 static struct workqueue_struct *rfcblk_work;
 
@@ -112,7 +112,7 @@ static struct rfcblk_device
 	struct gendisk *rfcblk_disk;
 } rfcblk_dev;
 
-struct list_head rdma_dev_list;
+static struct list_head rdma_dev_list;
 struct list_rdma_ip_dev {
 	char                node[264];
 	u32 ipaddr;
diff --git a/drivers/nvme/target/fc.c b/drivers/nvme/target/fc.c
index f053c8c..323547a 100644
--- a/drivers/nvme/target/fc.c
+++ b/drivers/nvme/target/fc.c
@@ -1708,7 +1708,7 @@ EXPORT_SYMBOL_GPL(nvmet_fc_rcv_ls_req);
  */
 //extern struct sg_table *rxe_get_target_sgl(void *buf, int len);
 
-u64 (*get_rdma_sgl_fn)(void *buf, int len, struct sg_table **rsgp,
+static u64 (*get_rdma_sgl_fn)(void *buf, int len, struct sg_table **rsgp,
 			char *name) = NULL;
 /*int fc_register_rdma_alloc_tgt_pgs(u64 (*fc_rdma_sgl_fn)(void *buf, int len,
 			struct sg_table **rsgp, char *name));*/
diff --git a/drivers/nvme/target/io-cmd.c b/drivers/nvme/target/io-cmd.c
index 9067bab..dec893b 100644
--- a/drivers/nvme/target/io-cmd.c
+++ b/drivers/nvme/target/io-cmd.c
@@ -36,7 +36,7 @@ static inline u32 nvmet_rw_len(struct nvmet_req *req)
 	return ((u32)le16_to_cpu(req->cmd->rw.length) + 1) <<
 			req->ns->blksize_shift;
 }
-u64 (*set_fc_rdma_done_fn)(void *buf, int len, char *name) = NULL;
+static u64 (*set_fc_rdma_done_fn)(void *buf, int len, char *name) = NULL;
 
 int fc_register_rdma_dma_done(u64 (*fc_rdma_dma_done_fn)(void *buf,
 	int len, char *name))